<?php 
/**
* cadenas.php
*
* cadena se incorpora en la carpeta includes 
* ya que contiene funciones genricas de operacin de cadenas (strings)
* 
* @package    	intraTReCC
* @subpackage 	Comun
* @author     	TReCC SA
* @author     	<mario@trecc.com.ar> <trecc@trecc.com.ar>
* @author    	www.trecc.com.ar  
* @copyright	2013 TReCC SA
* @license    	http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 (GPL-3.0)
* Este archivo es parte de TReCC(tm) intraTReCC y de sus proyectos hermanos: baseobra(tm) y TReCC(tm) paneldecontrol.
* Este archivo es software libre: tu puedes redistriburlo 
* y/o modificarlo bajo los trminos de la "GNU General Public License" 
* publicada por la Free Software Foundation, version 3
* 
* Este archivo es distribuido por si mismo y dentro de sus proyectos 
* con el objetivo de ser til, eficiente, predecible y transparente
* pero SIN NIGUNA GARANTA; sin siquiera la garanta implcita de
* CAPACIDAD DE MERCANTILIZACIN o utilidad para un propsito particular.
* Consulte la "GNU General Public License" para ms detalles.
* 
* Si usted no cuenta con una copia de dicha licencia puede encontrarla aqu: <http://www.gnu.org/licenses/>.
*/

header('Content-Type:text/html; charset=cp-1252');

/**
* genera una cadena aleatoria compatible con nombre de archivo (solo letras del alfabeto)
*
* @param integer $Largo cantidad de caracteres esperados
* @return string Retorna una cadena aleatoria compatible con nombre de archivo (solo letras del alfabeto)(diciembre de 2013)
*/
function cadenaArchivo( $Largo ) {
	$habilitados = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";	

	$largobase = strlen( $habilitados );
	for( $i = 0; $i < $Largo; $i++ ) {
		$resultado .= $habilitados[ rand( 0, $largobase - 1 ) ];
	}

	return $resultado;
}

/**
* genera un explode a partr de mltiples delimitadores
*
* @param array $delim array de delimietadores
* @param string $dato texto a explotar
* @return string Retorna un array resultado de los sucesivos explode(diciembre de 2013)
*/
function explodemulti($delim,$dato) {
	$array = explode($delim[0],$dato);
    array_shift($delim);
    foreach($array as $key => $texto) {
         $array[$key] = explodemulti($delim, $texto);
    }
    return  $array;
}

/**
* analiza que una cadena solo tenga caracteres vlidos para una direccin de mail
*
* @param string $mail direccin de email
* @return boolean Retorna true o false
*/
function mailvalido($mail) {
	$permitidos = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_-.@";
	for($i=0 ; $i < strlen($mail) ; $i++){
		if(strpos($permitidos, $mail[$i]) === false)
		return false;
	}
	
	$necesarios="@.";
	for($i=0 ; $i < strlen($necesarios) ; $i++){
		if(strpos($mail, $necesarios[$i]) === false)
		return false;
	}	
	
	return true;		
}


/**
* analiza que una cadena solo tenga caracteres vlidos para un nombre de usuario (log)
*
* @param string $log cuenta
* @return boolean Retorna true o false
*/
function logvalido($log){
	$permitidos = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_-";
	
	if(strlen($log)>4){
		for($i=0 ; $i < strlen($log) ; $i++)
		{
			if(strpos($permitidos, $log[$i]) === false)
			return false;
		}
		return true;	
	}
	
	return false;
}
/**
* analiza que una cadena solo tenga caracteres vlidos para una contrasea
*
* @param string $pass cuenta
* @return boolean Retorna true o false
*/
function passvalido($pass){
	$permitidos = " abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_-";
	
	if(strlen($pass)>4){
		for($i=0 ; $i < strlen($pass) ; $i++)
		{
			if(strpos($permitidos, $pass[$i]) === false)
			return false;
		}
		return true;			
	}
	return false;
}

/**
* codifica algunos caracteres ascii
*
* @param string $nombre nombre real 
* @return boolean Retorna true o false
*/
function decodeascii(){
	
}



/**
* analiza que una cadena solo tenga caracteres letras de la a a la z y espacios
*
* @param string $nombre nombre real 
* @return boolean Retorna true o false
*/
function nombrevalido($nombre) {
	$permitidos = " abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
	
	for($i=0 ; $i < strlen($nombre) ; $i++){
		$a = strpos($permitidos, $nombre[$i]);
		if($a === false){
			return false;
	
		}
	}
	return true;
}

/**
* analiza que una cadena se vlida como telfono
*
* @param string $tel
* @return boolean Retorna true o false
*/
function telvalido($tel) {
	$permitidos = " 0123456789-/()";
	
	if(strlen($tel)>4){
	for($i=0 ; $i < strlen($tel) ; $i++)
		{
			if(strpos($permitidos, $tel[$i]) === false)
			return false;
		}
	return true;	
	}
	return false;
}

/**
* analiza una formula y determina si es segura para ejecutar desde php. Solo permite matemtica bsica
*
* @param string $formula frmula a evaluar
* @return boolean Retorna true o false
*/
function formulaphpsegura($formula) {
	$permitidos = "123456789()[]+-*/ ";
	
	for($i=0 ; $i < strlen($tel) ; $i++)
		{
			if(strpos($permitidos, $tel[$i]) === false){
				return false;
			}
		}
	return true;	

}